# -*- coding: utf-8 -*-
"""
Éditeur de Spyder

Ceci est un script temporaire.
Algorithme du sac à dos. Act 1 p174-175 q.10

"""

import operator

def sac_a_dos(liste_id, liste_va, liste_ma, masse_maximale):
    n = len(liste_id)
    
    # Fabrication de la liste des valeurs massiques
    liste_va_ma = []
    for i in range(n):
        liste_va_ma.append(liste_va[i] / liste_ma[i])
        
     
    # Fabrication du tableau d'objets avec seulement les données utiles.
    tab_ob = []
    for i in range(n):
        tab_ob.append([liste_id[i], liste_ma[i], liste_va_ma[i]])
        
     
    # Fabrication du tableau trié par valeurs massiques décroissantes d'index 2
    tab_ob_trie = sorted(tab_ob, key=operator.itemgetter(2), reverse=True)
    # Alternative :
    # tab_ob_trie = sorted(tab_ob, key=lambda x: x[2], reverse=True)  

        
     
    # Fabrication du sac
    sac = []
    masse_sac = 0
    i = 0
    while masse_sac + tab_ob_trie[i][1] < masse_maximale:
        sac.append(tab_ob_trie[i][0])
        masse_sac = masse_sac + tab_ob_trie[i][1]
        i = i + 1
        
    return sac



ma_liste_id = [1, 2, 3, 4, 5, 6, 7]

ma_liste_va = [3, 5, 12, 30, 9, 10, 12]

ma_liste_ma = [0.5, 1, 1, 5, 6, 5, 3]

ma_masse_maximale = 10

print(sac_a_dos(ma_liste_id, ma_liste_va, ma_liste_ma, ma_masse_maximale))
        
